<?php
namespace Teknisa\DF\Controllers;

use Teknisa\DF\Services\Ger98600CodigoDeSituacaoDaOperacaoDoSimplesNacionalService;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\ParameterBag;
use Teknisa\Libs\Util\NewCode;

class Ger98600CodigoDeSituacaoDaOperacaoDoSimplesNacionalController extends \Teknisa\DF\Controllers\TeknisaCrud {

    protected $dataSourceName = "codfiscopersn_allDescriptions";
    protected $serviceCSOSN;
    protected $environment;
    protected $newCode;

    public function __construct($crudService, ParameterBag $parameterBag,Ger98600CodigoDeSituacaoDaOperacaoDoSimplesNacionalService $serviceCSOSN, $environment,NewCode $newCode) {
        $this->serviceCSOSN = $serviceCSOSN;
        $this->environment = $environment;
        $this->newCode = $newCode;
        parent::__construct($crudService, $parameterBag);
    }

    public function save(DTO\Request $request, DTO\Response $response) {
        $row = $request->getRow();
        $validate = $this->serviceCSOSN->validarCSONS($row);
        if($validate == true){
            if($row['__is_new'] === true)
                $row["NRINCIDCSOSN"] = $this->newCode->getCodeByTableName('CSOSN',$this->environment->getNrOrgTrab());

            parent::save($request,$response);
        }
        else{
		    $response->addDataset(new DataSet('validations', array( "validate" => $validate)));
        }
	}
}