<?php
namespace Teknisa\DF\Modules\Relatorios\Controllers;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DataSource\DataSet;
use Teknisa\DF\Modules\Relatorios\Services\Dfe26000InflacaoInterna;

class ItlanctoestInflacaointerna extends \Teknisa\DF\Controllers\TeknisaCrud {

	protected $Dfe26000InflacaoInterna;
	protected $dataSourceName = "itlanctoest_inflacaointerna";
	protected $parameterBagColumns = ["TIPOCUSTO",
		"NMTIPOCUSTO",
		"CDOPERENTR",
		"CDPRODFINAL",
		"CDFILIAL",
		"DATAINICIAL",
		"CDPRODINI",
		"DATAFINAL"];
		
	public function __construct($crudService, $parameterBag, Dfe26000InflacaoInterna $Dfe26000InflacaoInterna){
		parent::__construct($crudService, $parameterBag);
		$this->Dfe26000InflacaoInterna = $Dfe26000InflacaoInterna;
	}
	
	public function find(DTO\Request\Filter $request, DTO\Response $response){
		parent::find($request, $response);
		
		$dataSet = $response->getDataSets();

		if (count($dataSet) > 0){
			$rows = $dataSet[0]->getRows();
			$newRows = [];

			if(!is_null($rows)){
				foreach ($rows as $index => $value) {
					$inflacao = $this->Dfe26000InflacaoInterna->calculaInflacaoInterna($value['VRCUSTINIC'], $value['VRCUSTATUA']);
	
			
					$vrtotal = $this->Dfe26000InflacaoInterna->calculaValorTotal($value['VRCUSTINIC'],  $value['QTLANCTOEST']);

					$value['VRTOTAL'] = $vrtotal;
	
					$vrtotal = $this->Dfe26000InflacaoInterna->calculaValorTotal($value['VRCUSTATUA'], $value['QTLANCTOEST']);
					$value['VRTOTAL2'] = $vrtotal;
	
	
					$value['INFLACAO'] = $inflacao;
						
			

					$newRows[] = $value;
				}
				$dataSet = new DataSet('itlanctoest_inflacaointerna', $newRows);
				$response->setDataSets(array($dataSet));
			}
		}
	}
}